--- a/src/smooth/ftsmooth.c	2013-06-05 12:12:47.000000000 +0200
+++ b/src/smooth/ftsmooth.c	2013-11-25 22:29:19.846809862 +0100
@@ -104,8 +3103,9 @@
   {
     FT_Error     error;
     FT_Outline*  outline = NULL;
+    FT_Outline*  outline_orig = NULL;
     FT_BBox      cbox;
-    FT_Pos       width, height, pitch;
+    FT_Pos       width, height, pitch, ppem;
 #ifndef FT_CONFIG_OPTION_SUBPIXEL_RENDERING
     FT_Pos       height_org, width_org;
 #endif
@@ -123,6 +3123,483 @@
     FT_Bool  have_outline_shifted   = FALSE;
     FT_Bool  have_buffer            = FALSE;
 
+#ifdef FT_CONFIG_OPTION_INFINALITY_PATCHSET
+    FT_Matrix    scaleMat;
+    FT_Long      translate_value = 0;
+    float        scale_value = 1.0;
+    FT_Int       align_called = 0;
+
+
+    int          chromeos_style_sharpening_strength = 0;
+    int          checked_chromeos_style_sharpening_strength = 0;
+    int          alignment_strength = 0;
+    int          fitting_strength = 0;
+    FT_UInt      checked_alignment_strength = 0;
+    FT_UInt      checked_fitting_strength = 0;
+    FT_UInt      checked_fringe_filter_strength = 0;
+    int          fringe_filter_strength = 0;
+    FT_UInt      checked_grayscale_filter_strength = 0;
+    int          grayscale_filter_strength = 0;
+
+    FT_UInt      checked_autohint_horizontal_stem_darken_strength = 0;
+    int          autohint_horizontal_stem_darken_strength = 0;
+
+    FT_UInt      checked_autohint_vertical_stem_darken_strength = 0;
+    int          autohint_vertical_stem_darken_strength = 0;
+
+    int          windows_style_sharpening_strength = 0;
+    FT_UInt      checked_windows_style_sharpening_strength = 0;
+    float        gamma_correction_value = 1;
+    float        gamma_correction_lt = 0;
+    FT_UInt      checked_gamma_correction_value = 0;
+
+    FT_Int       brightness_value = 0.0;
+    FT_UInt      checked_brightness_value = 0;
+
+    FT_Int       contrast_value = 0.0;
+    FT_UInt      checked_contrast_value = 0;
+
+    FT_Int       snapping_sliding_scale_value = 0;
+    FT_UInt      checked_snapping_sliding_scale_value = 0;
+
+    FT_Int       global_embolden_x_value = 0;
+    FT_UInt      checked_global_embolden_x_value = 0;
+
+    FT_Int       global_embolden_y_value = 0;
+    FT_UInt      checked_global_embolden_y_value = 0;
+
+    FT_Int       bold_embolden_x_value = 0;
+    FT_UInt      checked_bold_embolden_x_value = 0;
+
+    FT_Int       bold_embolden_y_value = 0;
+    FT_UInt      checked_bold_embolden_y_value = 0;
+
+    FT_Byte      chromeos_cutoff;
+    double       chromeos_gamma_value;
+
+    float        embolden_value = 0.0;
+    FT_Bool      autohinted = FALSE;
+
+    FT_UInt      autohint_minimum_stem_height = 0;
+    FT_UInt      checked_autohint_minimum_stem_height = 0;
+
+    int          checked_use_various_tweaks_env = 0;
+    FT_Bool      use_various_tweaks = FALSE;
+
+    int          cur_width;
+    char         *cur_width_env = getenv( "CUR_WIDTH" );
+
+    const FT_Int MIN_PPEM = 1;
+    /*const FT_Int    MAX_PPEM = 100;    */
+
+    int checked_use_known_settings_on_selected_fonts_env = 0;
+    FT_Bool use_known_settings_on_selected_fonts = FALSE;
+
+    if ( slot->face                       &&
+         slot->face->size                 &&
+         slot->face->size->metrics.x_ppem )
+      ppem = slot->face->size->metrics.x_ppem;
+    else
+      ppem = 0;
+
+    if ( cur_width_env != NULL )
+    {
+      sscanf ( cur_width_env, "%d", &cur_width );
+
+      if ( cur_width != 0 )
+        autohinted = TRUE;
+    }
+
+    if ( checked_use_known_settings_on_selected_fonts_env == 0 )
+    {
+      char *use_known_settings_on_selected_fonts_env =
+        getenv( "INFINALITY_FT_USE_KNOWN_SETTINGS_ON_SELECTED_FONTS" );
+      if ( use_known_settings_on_selected_fonts_env != NULL )
+      {
+        if ( strcasecmp( use_known_settings_on_selected_fonts_env,
+                         "default" ) != 0 )
+        {
+          if ( strcasecmp( use_known_settings_on_selected_fonts_env,
+                           "true" ) == 0 )
+            use_known_settings_on_selected_fonts = TRUE;
+          else if ( strcasecmp( use_known_settings_on_selected_fonts_env,
+                                "1" ) == 0 )
+            use_known_settings_on_selected_fonts = TRUE;
+          else if ( strcasecmp( use_known_settings_on_selected_fonts_env,
+                                "on" ) == 0 )
+            use_known_settings_on_selected_fonts = TRUE;
+          else if ( strcasecmp( use_known_settings_on_selected_fonts_env,
+                                "yes" ) == 0 )
+            use_known_settings_on_selected_fonts = TRUE;
+        }
+      }
+      checked_use_known_settings_on_selected_fonts_env = 1;
+    }
+
+    if ( checked_use_various_tweaks_env == 0 )
+    {
+      char *use_various_tweaks_env
+        = getenv( "INFINALITY_FT_USE_VARIOUS_TWEAKS" );
+
+      if ( use_various_tweaks_env != NULL )
+      {
+        if ( strcasecmp( use_various_tweaks_env, "default" ) != 0 )
+        {
+          if ( strcasecmp( use_various_tweaks_env, "true") == 0)
+            use_various_tweaks = TRUE;
+          else if ( strcasecmp( use_various_tweaks_env, "1") == 0)
+            use_various_tweaks = TRUE;
+          else if ( strcasecmp( use_various_tweaks_env, "on") == 0)
+            use_various_tweaks = TRUE;
+          else if ( strcasecmp( use_various_tweaks_env, "yes") == 0)
+            use_various_tweaks = TRUE;
+        }
+      }
+      checked_use_various_tweaks_env = 1;
+    }
+
+    if ( checked_autohint_minimum_stem_height == 0 )
+    {
+      char *autohint_minimum_stem_height_env =
+        getenv( "INFINALITY_FT_AUTOHINT_MINIMUM_STEM_WIDTH" );
+
+        if ( autohint_minimum_stem_height_env != NULL )
+      {
+        sscanf ( autohint_minimum_stem_height_env, "%u",
+                 &autohint_minimum_stem_height );
+
+        if ( autohint_minimum_stem_height > 100 )
+          autohint_minimum_stem_height = 100;
+        else if ( autohint_minimum_stem_height < 0 )
+          autohint_minimum_stem_height = 0;
+      }
+      checked_autohint_minimum_stem_height = 1;
+    }
+
+    if ( checked_snapping_sliding_scale_value == 0 )
+    {
+      char *snapping_sliding_scale_env =
+        getenv ( "INFINALITY_FT_STEM_SNAPPING_SLIDING_SCALE" );
+
+      if ( snapping_sliding_scale_env != NULL )
+      {
+        sscanf ( snapping_sliding_scale_env, "%d",
+                 &snapping_sliding_scale_value );
+
+        if ( snapping_sliding_scale_value > MAX_PPEM )
+          snapping_sliding_scale_value = 0;
+        else if ( snapping_sliding_scale_value < 0 )
+          snapping_sliding_scale_value = 0;
+
+        if (snapping_sliding_scale_value < 11 &&
+            snapping_sliding_scale_value > 0  )
+          snapping_sliding_scale_value = 11;
+      }
+      checked_snapping_sliding_scale_value = 1;
+    }
+
+    if ( checked_alignment_strength == 0)
+    {
+      char *alignment_strength_env =
+        getenv ( "INFINALITY_FT_STEM_ALIGNMENT_STRENGTH" );
+
+      if ( alignment_strength_env != NULL )
+      {
+        sscanf ( alignment_strength_env, "%d", &alignment_strength );
+
+        if ( alignment_strength > 100 )
+          alignment_strength = 100;
+        else if ( alignment_strength < 0 )
+          alignment_strength = 0;
+      }
+
+      if ( alignment_strength > 100 )
+        alignment_strength = 100;
+      checked_alignment_strength = 1;
+
+      if ( snapping_sliding_scale_value != 0 )
+        alignment_strength = sliding_scale
+          ( 10, snapping_sliding_scale_value, alignment_strength, 100, ppem );
+    }
+
+    if ( checked_fitting_strength == 0 )
+    {
+      char *fitting_strength_env =
+        getenv( "INFINALITY_FT_STEM_FITTING_STRENGTH" );
+
+        if ( fitting_strength_env != NULL )
+      {
+        sscanf ( fitting_strength_env, "%d", &fitting_strength );
+
+        if ( fitting_strength > 100 )
+          fitting_strength = 100;
+        else if ( fitting_strength < 0 )
+          fitting_strength = 0;
+      }
+
+      if ( fitting_strength > 100 )
+        fitting_strength = 100;
+
+      checked_fitting_strength = 1;
+
+      if ( snapping_sliding_scale_value != 0 )
+        fitting_strength = sliding_scale
+          ( 10, snapping_sliding_scale_value, fitting_strength, 100, ppem );
+    }
+
+    if ( checked_chromeos_style_sharpening_strength == 0 )
+    {
+      char *chromeos_style_sharpening_strength_env =
+        getenv( "INFINALITY_FT_CHROMEOS_STYLE_SHARPENING_STRENGTH" );
+      if ( chromeos_style_sharpening_strength_env != NULL )
+      {
+        sscanf ( chromeos_style_sharpening_strength_env, "%d",
+                 &chromeos_style_sharpening_strength );
+
+        if ( chromeos_style_sharpening_strength > 100 )
+          chromeos_style_sharpening_strength = 100;
+        else if ( chromeos_style_sharpening_strength < 0 )
+          chromeos_style_sharpening_strength = 0;
+      }
+
+      if ( ppem > 10 )
+        chromeos_style_sharpening_strength =
+          ( chromeos_style_sharpening_strength * ppem ) / 10;
+
+      if ( chromeos_style_sharpening_strength > 100 )
+        chromeos_style_sharpening_strength = 100;
+      checked_chromeos_style_sharpening_strength = 1;
+    }
+
+
+    if ( checked_brightness_value == 0)
+    {
+      char *brightness_env = getenv( "INFINALITY_FT_BRIGHTNESS" );
+      if ( brightness_env != NULL )
+      {
+        sscanf ( brightness_env, "%d", &brightness_value );
+        if (brightness_value > 100 )
+          brightness_value = 100;
+        else if (brightness_value < -100 )
+          brightness_value = 0;
+      }
+      checked_brightness_value = 1;
+    }
+
+    if ( checked_contrast_value == 0)
+    {
+      char *contrast_env = getenv( "INFINALITY_FT_CONTRAST" );
+      if ( contrast_env != NULL )
+      {
+        sscanf ( contrast_env, "%d", &contrast_value );
+        if (contrast_value > 100 )
+          contrast_value = 100;
+        else if (contrast_value < -100 )
+          contrast_value = 100;
+      }
+      checked_contrast_value = 1;
+    }
+
+    if ( checked_windows_style_sharpening_strength == 0)
+    {
+      char *windows_style_sharpening_strength_env =
+        getenv( "INFINALITY_FT_WINDOWS_STYLE_SHARPENING_STRENGTH" );
+
+      if ( windows_style_sharpening_strength_env != NULL )
+      {
+        sscanf ( windows_style_sharpening_strength_env, "%d",
+                 &windows_style_sharpening_strength );
+
+        if ( windows_style_sharpening_strength > 100 )
+          windows_style_sharpening_strength = 100;
+        else if ( windows_style_sharpening_strength < 0 )
+          windows_style_sharpening_strength = 0;
+      }
+      /* Decrease effect slightly to have a more linear increase in sharpness */
+      windows_style_sharpening_strength =
+        ( ( windows_style_sharpening_strength
+            * windows_style_sharpening_strength ) / 100
+          + windows_style_sharpening_strength ) / 2;
+      checked_windows_style_sharpening_strength = 1;
+    }
+
+    if ( checked_gamma_correction_value == 0 )
+    {
+      char *gamma_correction_value_env =
+        getenv( "INFINALITY_FT_GAMMA_CORRECTION" );
+
+        if ( gamma_correction_value_env != NULL )
+      {
+        float f1, f2;
+
+        if ( strcasecmp( gamma_correction_value_env, "default" ) != 0 )
+        {
+          sscanf ( gamma_correction_value_env, "%f %f", &f1, &f2 );
+          gamma_correction_lt = f1;
+          gamma_correction_value = f2 / 100.0;
+        }
+        if ( gamma_correction_value < .01 ) gamma_correction_value = 1.0;
+      }
+      checked_gamma_correction_value = 1;
+    }
+
+    /* set gamma value to 1 if out of range */
+    if ( slot->face                       &&
+         slot->face->size                 &&
+         slot->face->size->metrics.x_ppem )
+    {
+      if ( slot->face->size->metrics.x_ppem >= gamma_correction_lt )
+        gamma_correction_value = 1;
+    }
+    else
+      gamma_correction_value = 1;
+
+
+    if ( checked_fringe_filter_strength == 0 )
+    {
+      char *fringe_filter_strength_env =
+        getenv( "INFINALITY_FT_FRINGE_FILTER_STRENGTH" );
+      if ( fringe_filter_strength_env != NULL )
+      {
+        sscanf ( fringe_filter_strength_env, "%d", &fringe_filter_strength );
+
+        if ( fringe_filter_strength > 100 )
+          fringe_filter_strength = 100;
+        else if ( fringe_filter_strength < 0 )
+          fringe_filter_strength = 0;
+      }
+      checked_fringe_filter_strength = 1;
+    }
+
+
+    if ( checked_grayscale_filter_strength == 0)
+    {
+      char *grayscale_filter_strength_env =
+        getenv( "INFINALITY_FT_GRAYSCALE_FILTER_STRENGTH" );
+      if ( grayscale_filter_strength_env != NULL )
+      {
+        sscanf ( grayscale_filter_strength_env, "%d",
+                 &grayscale_filter_strength );
+        if ( grayscale_filter_strength > 100 ) grayscale_filter_strength = 100;
+        else if (grayscale_filter_strength < 0 ) grayscale_filter_strength = 0;
+      }
+      checked_grayscale_filter_strength = 1;
+    }
+
+
+    if ( checked_autohint_horizontal_stem_darken_strength == 0)
+    {
+      char *autohint_horizontal_stem_darken_strength_env =
+        getenv( "INFINALITY_FT_AUTOHINT_HORIZONTAL_STEM_DARKEN_STRENGTH" );
+      if ( autohint_horizontal_stem_darken_strength_env != NULL )
+      {
+        sscanf ( autohint_horizontal_stem_darken_strength_env, "%d",
+                 &autohint_horizontal_stem_darken_strength );
+
+        if ( autohint_horizontal_stem_darken_strength > 100 )
+          autohint_horizontal_stem_darken_strength = 100;
+        else if ( autohint_horizontal_stem_darken_strength < 0 )
+          autohint_horizontal_stem_darken_strength = 0;
+      }
+      checked_autohint_horizontal_stem_darken_strength = 1;
+    }
+
+    if ( checked_autohint_vertical_stem_darken_strength == 0)
+    {
+      char *autohint_vertical_stem_darken_strength_env =
+        getenv( "INFINALITY_FT_AUTOHINT_VERTICAL_STEM_DARKEN_STRENGTH" );
+      if ( autohint_vertical_stem_darken_strength_env != NULL )
+      {
+        sscanf ( autohint_vertical_stem_darken_strength_env, "%d",
+                 &autohint_vertical_stem_darken_strength );
+
+        if ( autohint_vertical_stem_darken_strength > 100 )
+          autohint_vertical_stem_darken_strength = 100;
+        else if ( autohint_horizontal_stem_darken_strength < 0 )
+          autohint_vertical_stem_darken_strength = 0;
+      }
+      checked_autohint_vertical_stem_darken_strength = 1;
+    }
+
+    if ( checked_global_embolden_x_value == 0)
+    {
+      char *global_embolden_x_env =
+        getenv ( "INFINALITY_FT_GLOBAL_EMBOLDEN_X_VALUE" );
+      if ( global_embolden_x_env != NULL )
+      {
+        sscanf ( global_embolden_x_env, "%d", &global_embolden_x_value );
+
+        if ( global_embolden_x_value > 128 )
+          global_embolden_x_value = 128;
+        else if ( global_embolden_x_value < -128 )
+          global_embolden_x_value = -128;
+      }
+      checked_global_embolden_x_value = 1;
+    }
+
+    if ( checked_global_embolden_y_value == 0)
+    {
+      char *global_embolden_y_env =
+        getenv ( "INFINALITY_FT_GLOBAL_EMBOLDEN_Y_VALUE" );
+      if ( global_embolden_y_env != NULL )
+      {
+        sscanf ( global_embolden_y_env, "%d", &global_embolden_y_value );
+        if ( global_embolden_y_value > 128 )
+          global_embolden_y_value = 128;
+        else if ( global_embolden_y_value < -128 )
+          global_embolden_y_value = -128;
+      }
+      checked_global_embolden_y_value = 1;
+    }
+
+
+    if ( checked_bold_embolden_x_value == 0)
+    {
+      char *bold_embolden_x_env =
+        getenv ( "INFINALITY_FT_BOLD_EMBOLDEN_X_VALUE" );
+
+        if ( bold_embolden_x_env != NULL )
+      {
+        sscanf ( bold_embolden_x_env, "%d", &bold_embolden_x_value );
+        if (bold_embolden_x_value > 128 )
+          bold_embolden_x_value = 128;
+        else if (bold_embolden_x_value < -128 )
+          bold_embolden_x_value = -128;
+      }
+      checked_bold_embolden_x_value = 1;
+    }
+
+    if ( checked_bold_embolden_y_value == 0)
+    {
+      char *bold_embolden_y_env = getenv ( "INFINALITY_FT_BOLD_EMBOLDEN_Y_VALUE" );
+
+      if ( bold_embolden_y_env != NULL )
+      {
+        sscanf ( bold_embolden_y_env, "%d", &bold_embolden_y_value );
+        if (bold_embolden_y_value > 128 )
+          bold_embolden_y_value = 128;
+        else if (bold_embolden_y_value < -128 )
+          bold_embolden_y_value = -128;
+      }
+      checked_bold_embolden_y_value = 1;
+    }
+
+    if( use_various_tweaks     &&
+        slot->face             &&
+        slot->face->style_name )
+    {
+      /* needs to also check for artifical italics */
+      if ( strcasestr(slot->face->style_name, "Italic" )  ||
+           strcasestr(slot->face->style_name, "Oblique" ) )
+      {
+        windows_style_sharpening_strength = 0;
+        chromeos_style_sharpening_strength = 0;
+      }
+    }
+
+    /*if (fitting_strength == 100) scale_value = 1.1;*/
+
+#endif
 
     /* check glyph image format */
     if ( slot->format != render->glyph_format )
@@ -138,9 +3615,105 @@
       goto Exit;
     }
 
+#ifdef FT_CONFIG_OPTION_INFINALITY_PATCHSET
+RERENDER:
+    if ( align_called == 1 )
+    {
+      scaleMat.xx = FT_FixedFromFloat(scale_value);
+      scaleMat.xy = 0;
+      scaleMat.yx = 0;
+      scaleMat.yy = ( 1 << 16 );
+
+      FT_Outline_Copy(outline_orig, outline);
+
+      if ( scale_value != 1.0 )
+        FT_Outline_Transform( outline, &scaleMat );
+
+      FT_Outline_Translate( outline, translate_value, 0 );
+
+      FT_Outline_EmboldenXY( outline, embolden_value, 0 );
+    }
+    else
+    {
+#endif
     outline = &slot->outline;
+#ifdef FT_CONFIG_OPTION_INFINALITY_PATCHSET
+      /* Need to get this PRIOR to embolden, otherwise bad things happen */
+      FT_Outline_Get_CBox( outline, &cbox );
+
+      /* Various hacks that need to be turned into a new rule set */
+      /*if ( !autohinted
+        && use_known_settings_on_selected_fonts
+        && mode == FT_RENDER_MODE_LCD
+        && slot->face->family_name
+        && slot->face->style_name
+        && ( strcasestr(slot->face->family_name, "Courier New" )
+          && ( strcasestr(slot->face->style_name, "Regular" )
+            || strcasestr(slot->face->style_name, "Italic" ) ) ) )
+        FT_Outline_Embolden( outline, 24 );*/
+
+      if ( slot->face )
+      {
+        if ( !autohinted                                              &&
+            use_known_settings_on_selected_fonts                     &&
+            mode == FT_RENDER_MODE_LCD                               &&
+            slot->face->family_name                                  &&
+            slot->face->style_name                                   &&
+            strcasestr( slot->face->family_name, "Times New Roman" ) &&
+            strcasestr( slot->face->style_name, "Italic" )           )
+          FT_Outline_EmboldenXY( outline, 12, 0 );
+
+        if ( use_known_settings_on_selected_fonts              &&
+            autohinted                                        &&
+            mode == FT_RENDER_MODE_LCD                        &&
+            slot->face->family_name                           &&
+            slot->face->style_name                            &&
+            strcasestr(slot->face->family_name, "FreeSerif" ) &&
+            strcasestr(slot->face->style_name, "Italic" )     )
+          FT_Outline_EmboldenXY( outline, 8, 0 );
+
+        if ( global_embolden_x_value != 0 || global_embolden_y_value != 0 )
+              FT_Outline_EmboldenXY( outline,
+                                    global_embolden_x_value,
+                                    global_embolden_y_value );
+
+        if ( ( bold_embolden_x_value != 0 || bold_embolden_y_value != 0 ) &&
+            ( slot->face->style_name                             &&
+            ( strcasestr(slot->face->style_name, "Bold" ) ||
+              strcasestr(slot->face->style_name, "Black"  )    ||
+              ( slot->face->style_flags                      &&
+                slot->face->style_flags & FT_STYLE_FLAG_BOLD ) ) )       )
+          FT_Outline_EmboldenXY( outline,
+                                  bold_embolden_x_value,
+                                  bold_embolden_y_value );
+      }
+
+      FT_Outline_Copy( outline, outline_orig );
+    }
 
     /* translate the outline to the new origin if needed */
+    if ( align_called == 0 )
+    {
+      FT_Pos enlarge_cbox = 0;
+
+      /* enlarge for grayscale rendering */
+      if ( mode == FT_RENDER_MODE_NORMAL )
+        enlarge_cbox = 64;
+
+      if ( origin )
+      {
+        FT_Outline_Translate( outline, origin->x, origin->y );
+        have_translated_origin = TRUE;
+      }
+
+      /* compute the control box, and grid fit it */
+      /*FT_Outline_Get_CBox( outline, &cbox );*/
+
+      cbox.xMin = FT_PIX_FLOOR( cbox.xMin - enlarge_cbox );
+      cbox.yMin = FT_PIX_FLOOR( cbox.yMin );
+      cbox.xMax = FT_PIX_CEIL( cbox.xMax + enlarge_cbox );
+      cbox.yMax = FT_PIX_CEIL( cbox.yMax );
+#else
     if ( origin )
     {
       FT_Outline_Translate( outline, origin->x, origin->y );
@@ -154,6 +3727,7 @@
     cbox.yMin = FT_PIX_FLOOR( cbox.yMin );
     cbox.xMax = FT_PIX_CEIL( cbox.xMax );
     cbox.yMax = FT_PIX_CEIL( cbox.yMax );
+#endif
 
     if ( cbox.xMin < 0 && cbox.xMax > FT_INT_MAX + cbox.xMin )
     {
@@ -227,6 +3801,9 @@
         y_top   += extra >> 1;
       }
     }
+#endif
+#ifdef FT_CONFIG_OPTION_INFINALITY_PATCHSET
+    }
 
 #endif
 
@@ -251,6 +3828,9 @@
     bitmap->pitch      = pitch;
 
     /* translate outline to render it into the bitmap */
+#ifdef FT_CONFIG_OPTION_INFINALITY_PATCHSET
+    if ( align_called == 0 )
+#endif
     FT_Outline_Translate( outline, -x_shift, -y_shift );
     have_outline_shifted = TRUE;
 
@@ -306,9 +3886,153 @@
     if ( error )
       goto Exit;
 
+#ifdef FT_CONFIG_OPTION_INFINALITY_PATCHSET
+    if ( ppem <= MAX_PPEM && ppem >= MIN_PPEM )
+    {
+      if ( align_called == 0                                  &&  cur_width / ppem < 10 &&
+           ( alignment_strength > 0 || fitting_strength > 0 ) )
+        _lcd_stem_align ( bitmap,
+                          mode,
+                          slot,
+                          &translate_value,
+                          &scale_value,
+                          alignment_strength,
+                          fitting_strength,
+                          &embolden_value );
+
+      if ( align_called == 0                              &&
+           ( translate_value != 0 || scale_value != 1.0 ) )
+      {
+        align_called = 1;
+        goto RERENDER;
+      }
+
+      if ( mode == FT_RENDER_MODE_LCD )
+      {
+
+        if ( fringe_filter_strength > 0 /*&& autohinted*/ )
+          _ft_lcd_fringe_filter( bitmap,
+                                 mode,
+                                 fringe_filter_strength,
+                                 slot->library );
+
+        /*if ( autohinted)
+          _ft_lcd_stem_end_filter( bitmap, mode, 100, slot->library );*/
+
+        if ( gamma_correction_lt > 0 && gamma_correction_value != 1.0 )
+          _ft_lcd_gamma_correction_correction( bitmap,
+                                               mode,
+                                               slot,
+                                               gamma_correction_lt,
+                                               gamma_correction_value );
+
+        chromeos_cutoff = (FT_Byte)( 0.5 * 255.0 )
+                            * ( chromeos_style_sharpening_strength / 100.0 );
+        chromeos_gamma_value = 1;
+
+        if ( chromeos_style_sharpening_strength > 0 )
+          _ft_lcd_chromeos_sharpen( bitmap,
+                                    mode,
+                                    chromeos_cutoff,
+                                    chromeos_gamma_value );
+
+        if ( ppem > 8 )
+          if ( windows_style_sharpening_strength > 0 )
+            _ft_lcd_windows_sharpen( bitmap,
+                                     mode,
+                                     windows_style_sharpening_strength,
+                                     slot->library );
+
+        if ( autohinted                                    &&
+             ( cur_width * 100 ) / 64
+               > autohint_horizontal_stem_darken_strength  &&
+             autohint_horizontal_stem_darken_strength != 0 )
+          autohint_horizontal_stem_darken_strength = ( cur_width * 100 ) / 64;
+
+        if ( autohint_horizontal_stem_darken_strength > 100)
+          autohint_horizontal_stem_darken_strength = 100;
+
+        /* only do on autohinted fonts */
+        /* Necessary to do on some non-thin fonts, which is why it is outside */
+        /* of the below conditional */
+        if ( autohint_horizontal_stem_darken_strength > 0 && autohinted )
+          _ft_lcd_darken_x ( bitmap,
+                             mode,
+                             autohint_horizontal_stem_darken_strength,
+                             slot->library );
+
+        /* Enhance thin fonts */
+        if ( autohinted )
+        {
+          /* if forcibly set use that, otherwise make a good estimate */
+          if ( slot->face && !_ft_bitmap_bc ( bitmap,
+               (float)get_brightness( slot->face->family_name, ppem ) / 300.0,
+               (float)get_contrast( slot->face->family_name, ppem ) / 300.0 ) )
+          {
+            FT_Bool is_fixed_name = FALSE;
+
+            if ( slot->face->family_name                      &&
+                 strcasestr(slot->face->family_name, "Mono" ) )
+              is_fixed_name = TRUE;
+
+            /* Darken vertical stems */
+            _ft_lcd_darken_y ( bitmap,
+                               mode,
+                               autohint_vertical_stem_darken_strength,
+                               slot->library );
+
+            /* Adjust brightness / contrast automatically based on stem width */
+            if ( cur_width != 0 && cur_width < 30 )
+              cur_width = 30;
+ 
+            if ( cur_width >= 30 && cur_width <= 60 )
+            {
+              float ppem_factor       = sliding_scale ( 5, 11, 0.0, 1.0, ppem );
+              float brightness_factor = sliding_scale ( 30, 52, -.3, 0.0,
+                                                        cur_width );
+              float contrast_factor   = sliding_scale ( 30, 52, .45, 0.0,
+                                                        cur_width );
+              _ft_bitmap_bc ( bitmap,
+                              ppem_factor * brightness_factor,
+                              ppem_factor * contrast_factor );
+
+              /* Only cap variable width thin-stemmed fonts */
+              if ( !FT_IS_FIXED_WIDTH( slot->face ) && !is_fixed_name )
+                _ft_bitmap_cap ( bitmap,
+                                 ( cur_width * 150 ) / 64,
+                                 slot->library );
+            }
+          }
+        }
+
+
+        if ( slot->library->lcd_filter_func )
+          slot->library->lcd_filter_func( bitmap, mode, slot->library );
+
+        if ( grayscale_filter_strength > 0 )
+          _ft_lcd_grayscale_filter( bitmap,
+                                    mode,
+                                    grayscale_filter_strength,
+                                    slot->library );
+
+      }
+
+      /* Global values */
+      if ( brightness_value != 0 || contrast_value != 0 )
+        _ft_bitmap_bc ( bitmap,
+                        (float)brightness_value / 300.0,
+                        (float)contrast_value / 300.0);
+
+      FT_Outline_Done( slot->library, outline_orig );
+    }
+    else if ( mode == FT_RENDER_MODE_LCD     &&
+              slot->library->lcd_filter_func )
+          slot->library->lcd_filter_func( bitmap, mode, slot->library );
+#else
     if ( slot->library->lcd_filter_func )
       slot->library->lcd_filter_func( bitmap, mode, slot->library );
 
+#endif /* FT_CONFIG_OPTION_INFINALITY_PATCHSET */
 #else /* !FT_CONFIG_OPTION_SUBPIXEL_RENDERING */
 
     /* render outline into bitmap */
--- a/src/truetype/ttinterp.c	2013-11-02 11:26:59.000000000 +0100
+++ b/src/truetype/ttinterp.c	2013-11-25 22:29:19.850143195 +0100
@@ -4885,6 +4885,10 @@
     CUR.sph_in_func_flags = 0x0000;
 #endif /* TT_CONFIG_OPTION_SUBPIXEL_HINTING */
 
+#ifdef TT_CONFIG_OPTION_SUBPIXEL_HINTING
+    CUR.sph_in_func_flags = 0x0000;
+#endif /* TT_CONFIG_OPTION_SUBPIXEL_HINTING */
+
     if ( CUR.callTop <= 0 )     /* We encountered an ENDF without a call */
     {
       CUR.error = FT_THROW( ENDF_In_Exec_Stream );
@@ -6230,6 +6234,12 @@
                    ( CUR.sph_in_func_flags & SPH_FDEF_INLINE_DELTA_2 ) ) )
               goto Skip;
 
+            /* skip post-iup deltas */
+            if ( CUR.iup_called                                          &&
+                 ( ( CUR.sph_in_func_flags & SPH_FDEF_INLINE_DELTA_1 ) ||
+                   ( CUR.sph_in_func_flags & SPH_FDEF_INLINE_DELTA_2 ) ) )
+              goto Skip;
+
             if ( !( CUR.sph_tweak_flags & SPH_TWEAK_ALWAYS_SKIP_DELTAP ) &&
                   ( ( CUR.is_composite && CUR.GS.freeVector.y != 0 ) ||
                     ( CUR.zp2.tags[point] & FT_CURVE_TAG_TOUCH_Y )   ||
@@ -6519,6 +6529,7 @@
     if ( SUBPIXEL_HINTING                                  &&
          CUR.ignore_x_mode                                 &&
          CUR.GS.freeVector.x != 0                          &&
+         CUR.GS.freeVector.y == 0                          &&
          !( CUR.sph_tweak_flags & SPH_TWEAK_NORMAL_ROUND ) )
       minimum_distance = 0;
 #endif /* TT_CONFIG_OPTION_SUBPIXEL_HINTING */
@@ -8378,6 +8389,34 @@
 
 #endif /* TT_CONFIG_OPTION_SUBPIXEL_HINTING */
 
+#ifdef TT_CONFIG_OPTION_SUBPIXEL_HINTING
+      for ( i = 0; i < opcode_patterns; i++ )
+      {
+        if ( opcode_pointer[i] < opcode_size[i]                 &&
+             CUR.opcode == opcode_pattern[i][opcode_pointer[i]] )
+        {
+          opcode_pointer[i] += 1;
+
+          if ( opcode_pointer[i] == opcode_size[i] )
+          {
+            FT_TRACE7(( "sph: opcode ptrn: %d, %s %s\n",
+                        i,
+                        CUR.face->root.family_name,
+                        CUR.face->root.style_name ));
+
+            switch ( i )
+            {
+            case 0:
+              break;
+            }
+            opcode_pointer[i] = 0;
+          }
+        }
+        else
+          opcode_pointer[i] = 0;
+      }
+#endif /* TT_CONFIG_OPTION_SUBPIXEL_HINTING */
+
 #ifdef TT_CONFIG_OPTION_INTERPRETER_SWITCH
 
       {
